#include <stdio.h>

/* almoststrcpy - copies the null-termatied string str (including the null)
 *                to the buffer at address buf, except for the character at
 *                the zero-based index ind.
 */

void almoststrcpy( char* buf, char* str, int ind ) {
  int i = 0;

  /* iterate over all characters in string str (until null is encountered) */
  while( *str != '\0' ) {

    /* don't copy the character at index ind */
    if( i != ind ) {
      *buf = *str;
      buf++;
    }

    /* andvance string str pointer and index i */
    *str++;
    i++;
  }

  /* finally, put a null at the end of target buffer */
  *buf = '\0';
}

/* anagramRecursive - explaination of arguments...
 *
 * letters - a null-terminated sequence of characters that have not yet
 *           been included in the anagram being contructed at startString
 * startString - this is the start address an anagram being constructed
 * curString - this is an address in startString where this instantiation
 *             of anagramRecurse is going to start building an anagram
 */

void anagramRecursive( char* letters, char* startString, char* curString ) {
  char newLetters[256];
  int lettersIndex = 0;

  /* base case (no letters left to consider in letters array) */
  if( *letters == '\0' ) {
    *curString = '\0';
    printf( "%s\n", startString );
    return;
  }

  /* recursive case (consider each character in letters array) */
  do {

    /* put letters[lettersIndex] first in curString */
    *curString = letters[lettersIndex];

    /* shrink available letters in letters array (assign to newLetters) */
    almoststrcpy( newLetters, letters, lettersIndex );

    /* recurse with new set of letters */
    anagramRecursive( newLetters, startString, curString + 1 );

    lettersIndex++;
  } while( letters[lettersIndex] != '\0' );
}

void anagram( char* string ) {
  char buildString[256];   /* buffer in which anagrams are built */

  anagramRecursive( string, buildString, buildString );
}

int main( int argc, char* argv[] ) {
  char string[256];

  printf("Enter String: ");
  scanf("%s", string);
	
  anagram( string );

  return 0;

}
